/* Copyright (C) 2004 - 2007  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.nativequery.expr.cmp;


public class FieldValue extends ComparisonOperandDescendant {
	
	private String _fieldName;
	
	private Object _tag;
	
	public FieldValue(ComparisonOperandAnchor root, String name) {
		this(root, name, null);
	}
	
	public FieldValue(ComparisonOperandAnchor root, String name, Object tag) {
		super(root);
		_fieldName=name;
		_tag=tag;
	}

	public String fieldName() {
		return _fieldName;
	}
	
	public boolean equals(Object other) {
		if(!super.equals(other)) {
			return false;
		}
		FieldValue casted = (FieldValue) other;
		if(_tag==null) {
			if(casted._tag!=null) {
				return false;
			}
		}
		else {
			if(!_tag.equals(casted._tag)) {
				return false;
			}
		}
		return _fieldName.equals(casted._fieldName);
	}
	
	public int hashCode() {
		int hash=super.hashCode()*29+_fieldName.hashCode();
		if(_tag!=null) {
			hash*=29+_tag.hashCode();
		}
		return hash;
	}
	
	public String toString() {
		return super.toString()+"."+_fieldName;
	}
	
	public void accept(ComparisonOperandVisitor visitor) {
		visitor.visit(this);
	}
	
	/**
	 * Code analysis specific information.
	 * 
	 * This is used in the .net side to preserve Mono.Cecil references
	 * for instance.
	 */
	public Object tag() {
		return _tag;
	}
	
	public void tag(Object value) {
		_tag = value;
	}
}
