/* Copyright (C) 2004 - 2007  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.nativequery.main;

import java.util.*;

import org.apache.tools.ant.*;
import org.apache.tools.ant.types.*;

public class Db4oFileEnhancerAntTask extends Task {
	private String srcDir;
	private String targetDir;
	private List classPath=new ArrayList();
	private String packagePredicate;
	
	public void setSrcdir(String srcDir) {
		this.srcDir=srcDir;
	}
	
	public void setTargetdir(String targetDir) {
		this.targetDir=targetDir;
	}

	public void addClasspath(Path path) {
		classPath.add(path);
	}

	public void setPackagefilter(String packagePredicate) {
		this.packagePredicate=packagePredicate;
	}

	public void execute() {
		List paths=new ArrayList();
		for (Iterator pathIter = classPath.iterator(); pathIter.hasNext();) {
			Path path = (Path) pathIter.next();
			System.err.println(path.size());
			String[] curPaths=path.list();
			for (int curPathIdx = 0; curPathIdx < curPaths.length; curPathIdx++) {
				paths.add(curPaths[curPathIdx]);
			}
		}
		try {
			new Db4oFileEnhancer().enhance(srcDir,targetDir,(String[])paths.toArray(new String[paths.size()]),(packagePredicate==null ? "" : packagePredicate));
		} catch (Exception exc) {
			throw new BuildException(exc);
		}
	}
}
